//+------------------------------------------------------------------+
//|                                       EMA With RSI and Stoch.mq4 |
//|                                                   Amritendu Maji |
//+------------------------------------------------------------------+
#property copyright "Amritendu Maji"
#property link      "None"

extern double Lots=0.1;
extern int Slippage=3;

extern int FastPeriod = 5;
extern int SlowPeriod = 10;
extern int RSIPeriod = 14;
extern int StochKPer = 10;
extern int StochDPer = 3;
extern int StochPeriod = 3;

extern double RSIOverSold = 20;
extern double RSIOverBought = 80;
extern double RSIMid = 50;
extern double StochOverSold = 30;
extern double StochOverBought = 70;

extern int StretchPips = 15;
extern int StopLoss = 100;
extern int TakeProfit1 = 0;
extern int TakeProfit2 = 100;
extern int TakeProfit3 = 0;
extern int BreakEvenPips = 50;
extern int TrailStopPips = 50;
extern int TrailStartPips = 50; 

extern int TimeFrame = 0;
extern int MaxTrades = 1;

extern bool MM = true; //Use Money Management or not
extern int RiskPercent = 1; //%  per trade

double iLots;
string EAName = "EMA With RSI and Stoch";
int MagicNumber=14545;
datetime expiration = 0, timeprev=0;
double price, prcopp, Spread, MinStretch;
double LongEntry, ShortEntry;
double SMA1, SMA2, FMA1, FMA2, RSI1, RSI2, STO1, STO2;

int init()
{
 MagicNumber = MagicfromSymbol();
 return(0);
}

int deinit()
{
 return(0);
}

int start()
{


//  TrailingAlls(TrailStartPips, TrailStopPips);  
//  BreakEven(BreakEvenPips);

//
//New Bar
//

 if(timeprev==Time[0])
  return(0);
 timeprev=Time[0];
 
   if(MM==true) 
    iLots = LotSize(StopLoss);
   else
    iLots = Lots;
 
 Spread = MarketInfo(Symbol(), MODE_SPREAD)*Point;
 MinStretch = MarketInfo(Symbol(), MODE_STOPLEVEL)*Point;
 
 FMA1 = iMA(Symbol(),TimeFrame,FastPeriod,0,MODE_EMA,PRICE_CLOSE,1);
 FMA2 = iMA(Symbol(),TimeFrame,FastPeriod,0,MODE_EMA,PRICE_CLOSE,2);
 SMA1 = iMA(Symbol(),TimeFrame,SlowPeriod,0,MODE_EMA,PRICE_CLOSE,1);
 SMA2 = iMA(Symbol(),TimeFrame,SlowPeriod,0,MODE_EMA,PRICE_CLOSE,2);
 RSI1 = iRSI(Symbol(),TimeFrame,RSIPeriod,PRICE_CLOSE,1);
 RSI2 = iRSI(Symbol(),TimeFrame,RSIPeriod,PRICE_CLOSE,2);
 STO1 = iStochastic(Symbol(),TimeFrame,StochKPer,StochDPer,StochPeriod,MODE_SMA,0,0,1);
 STO1 = iStochastic(Symbol(),TimeFrame,StochKPer,StochDPer,StochPeriod,MODE_SMA,0,0,2);
 
 bool buy=false, sell=false;
 
 if(((FMA1>SMA1)&&(FMA2<SMA2)) || ((RSI1<RSIMid)&&(RSI1>RSIMid)))
 {
  ClosePendingShorts();
  CloseShorts();
 }

 if(((FMA1<SMA1)&&(FMA2>SMA2)) || ((RSI1>RSIMid)&&(RSI1<RSIMid)))
 {
  ClosePendingLongs();
  CloseLongs();
 }
 
 buy = (FMA1>SMA1) && (FMA2<SMA2)  && (STO1<StochOverBought) && (RSI1>RSIMid) && (RSI1<RSIOverBought);
 sell = (FMA1<SMA1) && (FMA2>SMA2)  && (STO1>StochOverSold) && (RSI1<RSIMid) && (RSI1>RSIOverSold);


 if(buy && (CountTrades()<MaxTrades))
 {
   price = Ask;
   prcopp = Bid;
   OpenPendingOrder(OP_BUY,iLots,price,Slippage,prcopp,StopLoss,TakeProfit1,EAName+"1st",MagicNumber,expiration,Lime);
 }
 
 if(sell && (CountTrades()<MaxTrades))
 {
   price = Bid;
   prcopp = Ask;
   OpenPendingOrder(OP_SELL,iLots,price,Slippage,prcopp,StopLoss,TakeProfit1,EAName+"1st",MagicNumber,expiration,Lime);
 }
  
 return(0);
}


double StopLong(double price,int stop)
{
 if(stop==0)
  return(0);
 else
  return(price-(stop*Point));
}

double StopShort(double price,int stop)
{
 if(stop==0)
  return(0);
 else
  return(price+(stop*Point));
}

double TakeLong(double price,int take)
{
 if(take==0)
  return(0);
 else
  return(price+(take*Point));
}

double TakeShort(double price,int take)
{
 if(take==0)
  return(0);
 else
  return(price-(take*Point));
}


void TrailingAlls(int start,int stop)
{
 int profit;
 double stoptrade;
 double stopcal;
 
 if(stop==0)
  return;
 
 int trade;
 for(trade=OrdersTotal()-1;trade>=0;trade--)
 {
  if(!OrderSelect(trade,SELECT_BY_POS,MODE_TRADES))
   continue;

  if(OrderSymbol()!=Symbol()||OrderMagicNumber()!=MagicNumber)
   continue;
   
  if(OrderSymbol()==Symbol()&&OrderMagicNumber()==MagicNumber)   
  {
   if(OrderType()==OP_BUY)
   {
    profit=NormalizeDouble((Bid-OrderOpenPrice())/Point,0);
    if(profit<start)
     continue;
    stoptrade=OrderStopLoss();
    stopcal=Bid-(stop*Point);
    if(stoptrade==0||(stoptrade!=0&&stopcal>stoptrade))
     OrderModify(OrderTicket(),OrderOpenPrice(),stopcal,OrderTakeProfit(),0,Blue);
   }//Long
  
   if(OrderType()==OP_SELL)
   {
    profit=NormalizeDouble((OrderOpenPrice()-Ask)/Point,0);
    if(profit<start)
     continue;
    stoptrade=OrderStopLoss();
    stopcal=Ask+(stop*Point);
    if(stoptrade==0||(stoptrade!=0&&stopcal<stoptrade))
     OrderModify(OrderTicket(),OrderOpenPrice(),stopcal,OrderTakeProfit(),0,Red);
   }//Shrt
  }
 }//for
}

void CloseAll(int LiveHour)
{
 int trade;
 bool closetime=false;
 
 for(trade=OrdersTotal()-1;trade>=0;trade--)
 {
  OrderSelect(trade,SELECT_BY_POS,MODE_TRADES);

  if(OrderSymbol()!=Symbol())
   continue;
   
  if(OrderSymbol()==Symbol()&&OrderMagicNumber()==MagicNumber)   
  { 
   if (TimeHour(Time[0]) == (TimeHour(OrderOpenTime()+LiveHour*60*60))) closetime = true;
  
   if((closetime)&&(OrderType()==OP_BUY))
    OrderClose(OrderTicket(),OrderLots(),Bid,Slippage,Blue);

   if((closetime)&&(OrderType()==OP_SELL))
    OrderClose(OrderTicket(),OrderLots(),Ask,Slippage,Red);
  }
 }//for
}

void CloseLongs()
{
 int trade;
 for(trade=OrdersTotal()-1;trade>=0;trade--)
 {
  OrderSelect(trade,SELECT_BY_POS,MODE_TRADES);

  if(OrderSymbol()!=Symbol()||OrderMagicNumber()!=MagicNumber)
   continue;
   
  if(OrderSymbol()==Symbol()&&OrderMagicNumber()==MagicNumber)
  {   
   if(OrderType()==OP_BUY)
    OrderClose(OrderTicket(),OrderLots(),Bid,Slippage,Blue);
  } 
 }//for
}


void ClosePendingLongs()
{
 int trade;
 for(trade=OrdersTotal()-1;trade>=0;trade--)
 {
  OrderSelect(trade,SELECT_BY_POS,MODE_TRADES);

  if(OrderSymbol()!=Symbol()||OrderMagicNumber()!=MagicNumber)
   continue;
   
  if(OrderSymbol()==Symbol()&&OrderMagicNumber()==MagicNumber)
  {   
   if(OrderType()==OP_BUYSTOP)
    OrderDelete(OrderTicket());
  } 
 }//for
}


void CloseShorts()
{
 int trade;
 for(trade=OrdersTotal()-1;trade>=0;trade--)
 {
  OrderSelect(trade,SELECT_BY_POS,MODE_TRADES);

  if(OrderSymbol()!=Symbol()||OrderMagicNumber()!=MagicNumber)
   continue;

  if(OrderSymbol()==Symbol()&&OrderMagicNumber()==MagicNumber) 
  {  
   if(OrderType()==OP_SELL)
    OrderClose(OrderTicket(),OrderLots(),Ask,Slippage,Red);
  }
 }//for
}

void ClosePendingShorts()
{
 int trade;
 for(trade=OrdersTotal()-1;trade>=0;trade--)
 {
  OrderSelect(trade,SELECT_BY_POS,MODE_TRADES);

  if(OrderSymbol()!=Symbol()||OrderMagicNumber()!=MagicNumber)
   continue;

  if(OrderSymbol()==Symbol()&&OrderMagicNumber()==MagicNumber) 
  {  
   if(OrderType()==OP_SELLSTOP)
    OrderDelete(OrderTicket());
  }
 }//for
}

int CountTrades()
{
 int count=0;
 int trade;
 for(trade=OrdersTotal()-1;trade>=0;trade--)
 {
  OrderSelect(trade,SELECT_BY_POS,MODE_TRADES);
  
  if(OrderSymbol()!=Symbol()||OrderMagicNumber()!=MagicNumber)
   continue;
   
  if(OrderSymbol()==Symbol()&&OrderMagicNumber()==MagicNumber)   
  if(OrderType()==OP_BUY || OrderType()==OP_BUYSTOP ||
     OrderType()==OP_SELL || OrderType()==OP_SELLSTOP)
   count++;
 }//for
 return(count);
}


int MagicfromSymbol() 
{
   int magic=0;
   string var1=EAName;
   for (int i=0; i<6; i++) { 
      magic=magic*7+StringGetChar(Symbol(),i);
   }
   magic=magic*3+Period();
   magic= magic + StrToInteger(var1);
   return(magic);
}

int OpenPendingOrder(int pType,double pLots,double pLevel,int sp, double pr, int sl, int tp,string pComment,int pMagic,datetime pExpiration,color pColor)
{
  int ticket=0;
  int err=0;
  int c = 0;
  int NumberOfTries = 100;
  switch (pType)
  {
      case OP_BUYLIMIT:
         for(c = 0 ; c < NumberOfTries ; c++)
         {
            ticket=OrderSend(Symbol(),OP_BUYLIMIT,pLots,pLevel,sp,StopLong(pr,sl),TakeLong(pLevel,tp),pComment,pMagic,pExpiration,pColor);
            if (ticket > 0) break;
            err=GetLastError();
            if(err==0)
            { 
               break;
            }
            else
            {
               if(err==4 || err==137 ||err==146 || err==136) //Busy errors
               {
                  Sleep(1000);
                  continue;
               }
               else //normal error
               {
                  break;
               }  
            }
         }   
         break;
      case OP_BUYSTOP:
         for(c = 0 ; c < NumberOfTries ; c++)
         {
            ticket=OrderSend(Symbol(),OP_BUYSTOP,pLots,pLevel,sp,StopLong(pr,sl),TakeLong(pLevel,tp),pComment,pMagic,pExpiration,pColor);
            if (ticket > 0) break;
            err=GetLastError();
/*
            if(handle>0)
            {
             FileWrite(handle, TimeToStr(CurTime()), ticket, Symbol(),"BUYSTOP",pLots,pLevel,sp,sl,StopLong(pr,sl),tp, TakeLong(pLevel,tp),pComment,pMagic,pExpiration,pColor);
             FileWrite(handle, "Ask= ", Ask, " Bid = ", Bid);
             FileWrite(handle, "Error Code= ", err, " Ticket = ", ticket);
            }

*/            
            if(err==0)
            { 
               break;
            }
            else
            {
               if(err==4 || err==137 ||err==146 || err==136) //Busy errors
               {
                  Sleep(5000);
                  continue;
               }
               else //normal error
               {
                  break;
               }  
            }
         } 
         break;
      case OP_BUY:
         for(c = 0 ; c < NumberOfTries ; c++)
         {
            ticket=OrderSend(Symbol(),OP_BUY,pLots,pLevel,sp,StopLong(pr,sl),TakeLong(pLevel,tp),pComment,pMagic,pExpiration,pColor);
            if (ticket > 0) break;
            err=GetLastError();
            if(err==0)
            { 
               break;
            }
            else
            {
               if(err==4 || err==137 ||err==146 || err==136) //Busy errors
               {
                  Sleep(5000);
                  continue;
               }
               else //normal error
               {
                  Print("Error Code= ", err);
                  break;
               }  
            }
         } 
         break;
      case OP_SELLLIMIT:
         for(c = 0 ; c < NumberOfTries ; c++)
         {
            ticket=OrderSend(Symbol(),OP_SELLLIMIT,pLots,pLevel,sp,StopShort(pr,sl),TakeShort(pLevel,tp),pComment,pMagic,pExpiration,pColor);
            if (ticket > 0) break;
            err=GetLastError();
            if(err==0)
            { 
               break;
            }
            else
            {
               if(err==4 || err==137 ||err==146 || err==136) //Busy errors
               {
                  Sleep(5000);
                  continue;
               }
               else //normal error
               {
                  Print("Error Code= ", err);
                  break;
               }  
            }
         } 
         break;
      case OP_SELLSTOP:
         for(c = 0 ; c < NumberOfTries ; c++)
         {
            ticket=OrderSend(Symbol(),OP_SELLSTOP,pLots,pLevel,sp,StopShort(pr,sl),TakeShort(pLevel,tp),pComment,pMagic,pExpiration,pColor);
            if (ticket > 0) break;
            err=GetLastError();
/*
            if(handle>0)
            {
             FileWrite(handle, TimeToStr(CurTime()), ticket, Symbol(),"SELLSTOP",pLots,pLevel,sp,sl, StopShort(pr,sl),tp, TakeShort(pLevel,tp),pComment,pMagic,pExpiration,pColor);
             FileWrite(handle, "Ask= ", Ask, " Bid = ", Bid);
             FileWrite(handle, "Error Code= ", err, " Ticket = ", ticket);
            }

*/            if(err==0)
            { 
               break;
            }
            else
            {
               if(err==4 || err==137 ||err==146 || err==136) //Busy errors
               {
                  Sleep(5000);
                  continue;
               }
               else //normal error
               {
                  Print("Error Code= ", err);
                  break;
               }  
            }
         } 
         break;
      case OP_SELL:
         for(c = 0 ; c < NumberOfTries ; c++)
         {
            ticket=OrderSend(Symbol(),OP_SELL,pLots,pLevel,sp,StopShort(pr,sl),TakeShort(pLevel,tp),pComment,pMagic,pExpiration,pColor);
            if (ticket > 0) break;
            err=GetLastError();
            if(err==0)
            { 
               break;
            }
            else
            {
               if(err==4 || err==137 ||err==146 || err==136) //Busy errors
               {
                  Sleep(5000);
                  continue;
               }
               else //normal error
               {
                  Print("Error Code= ", err);
                  break;
               }  
            }
         } 
         break;
  } 
  
  return(ticket);
}  



// ---- Money Management

double LotSize(double StopLossInPips)
{ 
 int Leverage =  AccountLeverage(); 
 double PipValue = MarketInfo(Symbol(), MODE_TICKVALUE);
 double lotMM, FreeMargin;
 
 FreeMargin = AccountFreeMargin();
 lotMM = NormalizeDouble((FreeMargin*RiskPercent/100)/(StopLossInPips*PipValue),1);
   
   if (lotMM < 0.1) lotMM = Lots;
   if  (lotMM > 100) lotMM = 100;
   return (lotMM);
} 
 



void BreakEven(int stop)
{
 int profit, start, trade;
 double stoptrade, stopcal;
 
 if(stop==0)
  return;
 
 for(trade=OrdersTotal()-1;trade>=0;trade--)
 {
  if(!OrderSelect(trade,SELECT_BY_POS,MODE_TRADES))
   continue;

  if(OrderSymbol()!=Symbol()||OrderMagicNumber()!=MagicNumber)
   continue;
   
  if(OrderSymbol()==Symbol()&&OrderMagicNumber()==MagicNumber)   
  {
   if(OrderType()==OP_BUY)
   {
    profit=NormalizeDouble((Bid-OrderOpenPrice())/Point,0);
    stopcal=OrderOpenPrice() + Spread +(stop*Point);
    if(profit<0)
     continue;
    else if(profit==NormalizeDouble(stopcal/Point, 0))
    {
     OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice()+Spread,OrderTakeProfit(),0,Lime);
     Sleep(5000);
     RefreshRates();
    }
   }//Long
  
   if(OrderType()==OP_SELL)
   {
    profit=NormalizeDouble((OrderOpenPrice()-Ask)/Point,0);
    stopcal=OrderOpenPrice() - (stop*Point);
    if(profit<0)
     continue;
    else if(profit==NormalizeDouble(stopcal/Point, 0))
    {
     OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice()-Spread,OrderTakeProfit(),0,HotPink);
     Sleep(5000);
     RefreshRates();
    }
   }//Short
  }
 }//for
}



